#include "config.h"
#include <errno.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h> 

static char rcsid[] = "$Id: util.c,v 1.1 1996/07/31 00:08:58 sano Exp $";

char  line[16];

int
openpty(master, slave, name, termp, winp)
	int *master, *slave;
	char *name;
	struct termios *termp;
	struct winsize *winp;
{
	int   i, j;

	for (i = 'p'; i<= 's'; i++)
		for (j = 0; j <= 15; j++) {
			sprintf(line, "/dev/pty%c%x", i, j);
			if ((*master = open(line, O_RDWR)) == -1) {
				if (errno == ENOENT)
					return -1;
			} else {
				sprintf(line, "/dev/tty%c%x", i, j);
				if ((*slave = open(line, O_RDWR)) == -1)
					close(*master);
				else {
					if (name)
						strcpy(name, line);
					if (termp)
						tcsetattr(*slave, TCSAFLUSH, termp);
					if (winp)
						ioctl(*slave, TIOCSWINSZ, (char *)winp);
					/*printf("open %s, master:%d, slave:%d\n", line, *master, *slave); /**/

					return 0;
				}
			} 
		}
	errno = ENOENT;
	return -1;
}

void
cfmakeraw(t)
        struct termios *t;
{

        t->c_iflag &= ~(IMAXBEL|IXOFF|INPCK|BRKINT|PARMRK|
			ISTRIP|INLCR|IGNCR|ICRNL|IXON|IGNPAR);
        t->c_iflag |= IGNBRK;
        t->c_oflag &= ~OPOST;
        t->c_lflag &= ~(ECHO|ECHOE|ECHOK|ECHONL|ICANON|ISIG|
			IEXTEN|NOFLSH|TOSTOP|PENDIN);
        t->c_cflag &= ~(CSIZE|PARENB);
        t->c_cflag |= CS8|CREAD;
        t->c_cc[VMIN] = 1;
        t->c_cc[VTIME] = 0;
}

int
login_tty(fd)
{
	int t;

	if ((t = open("/dev/tty", O_RDWR)) >= 0) {
		ioctl(t, TIOCNOTTY, (char *)0);
		close(t);
	}

	close(open(line, O_RDWR));   /* XXX */
	
	dup2(fd, 0);
	dup2(fd, 1);
	dup2(fd, 2);
	close(fd);
	return 0;
}

/*
 * Local Variables:
 *  c-indent-level:               8
 *  c-continued-statement-offset: 8
 *  c-continued-brace-offset:     0
 *  c-brace-offset:              -8
 *  c-brace-imaginary-offset:     0
 *  c-argdecl-indent:             8
 *  c-label-offset:              -8
 *  c++-hanging-braces:           1
 *  c++-access-specifier-offset: -8
 *  c++-empty-arglist-indent:     8
 *  c++-friend-offset:            0
 * End:
 */
